--- groff-1.18.orig/src/roff/troff/env.cc
+++ groff-1.18/src/roff/troff/env.cc
@@ -32,6 +32,7 @@
 #include "charinfo.h"
 #include "macropath.h"
 #include "input.h"
+#include "font.h" // NIPPON only?
 #include <math.h>
 
 symbol default_family("T");
@@ -286,10 +287,82 @@
   else {
     if (line == 0)
       start_line();
+#ifdef	NIPPON
+    if (!ci->get_wchar_code()) {
+      /*
+       * This node is a ASCII character node.
+       */
+      if (!pre_char_is_ascii && enable_wcharkern && !hwkern.is_zero()) {
+	/*
+	 * Insert a little space node between EUC and ASCII.
+	 */
+	word_space_node *ws;
+
+	if (ci->ends_sentence() || ci->transparent() || ci->cannot_break_before())
+	  ws = new unbreakable_space_node(hwkern.to_units());
+	else
+	  ws = new word_space_node(hwkern.to_units(),
+				   new width_list(env_space_width(this),
+						  env_sentence_space_width(this)));
+	curenv->add_node(ws);
+      }
+      pre_char_is_ascii = 1;
+      pre_wchar_cannot_break_after = 0;
+    } else {
+      /*
+       * This node is a EUC charcater node.
+       */
+      if (!pre_char_is_ascii && line->get_node_type() == NODE_NEWLINE_SPACE) {
+	/*
+	 * remove a newline-node.
+	 */
+	node *ns_node = line;
+	line = line->next;
+	width_total -= ns_node->width();
+	space_total -= ns_node->nspaces();
+	delete ns_node;
+      }
+
+      if (!pre_wchar_cannot_break_after && !ci->cannot_break_before()) {
+	/*
+	 * add a zero-width-space-node before EUC charcater node.
+	 */
+	add_node(new kword_space_node());
+	met_with_kword_space = 1;
+      }
+      pre_wchar_cannot_break_after = ci->cannot_break_after();
+
+      if (pre_char_is_ascii && enable_wcharkern && !hwkern.is_zero()) {
+	/*
+	 * Insert a little space node between ASCII and EUC.
+	 */
+	unbreakable_space_node *ws =
+	  new unbreakable_space_node(hwkern.to_units());
+	curenv->add_node(ws);
+      }
+      pre_char_is_ascii = 0;
+
+      if (!vlower.is_zero()) {
+	/*
+	 * Lower a EUC charcater node.
+	 */
+	curenv->add_node(new vmotion_node(vlower.to_units())); // lower
+      }
+    }
+#endif
     if (ci != hyphen_indicator_char)
       line = line->add_char(ci, this, &width_total, &space_total);
     else
       line = line->add_discretionary_hyphen();
+#ifdef	NIPPON
+    enable_wcharkern = 1;
+    if (!vlower.is_zero() && ci->get_wchar_code()) {
+      /*
+       * Raise a EUC charcater node.
+       */
+      curenv->add_node(new vmotion_node(-vlower.to_units())); // raise
+    }
+#endif
   }
 }
 
@@ -394,7 +467,11 @@
     width_total += x;
     return;
   }
+#ifdef	NIPPON
+  add_node(new newline_space_node(x)); // This node may be removed.
+#else
   add_node(new word_space_node(x, w));
+#endif
   possibly_break_line(0, spread_flag);
   spread_flag = 0;
 }
@@ -479,6 +556,27 @@
     warning(WARN_FONT, "bad font number");
 }
 
+#ifdef	NIPPON
+void environment::change_curfont(symbol nm)
+{
+  int n = symbol_fontno(nm);
+  if (n < 0) {
+    n = next_available_font_position();
+    if (!mount_font(n, nm))
+      return;
+  }
+  fontno = n;
+}
+
+void environment::change_curfont(int n)
+{
+  if (is_good_fontno(n))
+    fontno = n;
+  else
+    error("bad font number");
+}
+#endif /* NIPPON */
+
 void environment::set_family(symbol fam)
 {
   if (interrupted)
@@ -648,6 +746,16 @@
   control_char('.'),
   no_break_control_char('\''),
   hyphen_indicator_char(0)
+#ifdef	NIPPON
+  ,
+  stretch_threshold(0),
+  pre_wchar_cannot_break_after(0),
+  pre_char_is_ascii(-1),
+  enable_wcharkern(0),
+  met_with_kword_space(0),
+  hwkern(font::wcharkern),
+  vlower(font::lowerwchar)
+#endif
 {
   prev_family = family = lookup_family(default_family);
   prev_fontno = fontno = 1;
@@ -738,6 +846,16 @@
   control_char(e->control_char),
   no_break_control_char(e->no_break_control_char),
   hyphen_indicator_char(e->hyphen_indicator_char)
+#ifdef	NIPPON
+  ,
+  stretch_threshold(e->stretch_threshold),
+  pre_wchar_cannot_break_after(0),
+  pre_char_is_ascii(-1),
+  enable_wcharkern(0),
+  met_with_kword_space(0),
+  hwkern(font::wcharkern),
+  vlower(font::lowerwchar)
+#endif
 {
 }
 
@@ -1779,6 +1897,9 @@
   target_text_length = line_length - saved_indent;
   width_total = H0;
   space_total = 0;
+#ifdef	NIPPON
+  enable_wcharkern = 0;
+#endif
 }
 
 hunits environment::get_hyphenation_space()
@@ -1817,6 +1938,23 @@
   skip_line();
 }
 
+#ifdef NIPPON
+void stretch_threshold_request()
+{
+  int n;
+  if (has_arg() && get_integer(&n)) {
+      if (n < 0 || n > 100) {
+	  warning(WARN_RANGE, "stretch threshold value %1 out of range", n);
+      } else {
+	  curenv->stretch_threshold = n;
+      }
+  } else {
+      curenv->stretch_threshold = 0;
+  }
+  skip_line();
+}
+#endif
+
 breakpoint *environment::choose_breakpoint()
 {
   hunits x = width_total;
@@ -2012,6 +2150,30 @@
 	     // When a macro follows a paragraph in fill mode, the
 	     // current line should not be empty.
 	     || (width_total - line->width()) > target_text_length)) {
+#ifdef NIPPON
+    if (met_with_kword_space) {
+      node *linep = line;
+      node *prep = 0;
+      while (linep->next) {
+      if (linep->next->get_node_type() == NODE_GLYPH)
+        prep = 0;
+      else if (linep->next->get_node_type() == NODE_KWORD_SPACE)
+        prep = linep;
+        linep = linep->next;
+      }
+      if (prep) {
+        /*
+         * delete a kword_space_node which is in the top of line.
+         */
+        linep = prep->next;
+        prep->next = linep->next;
+        width_total -= linep->width();
+        space_total -= linep->nspaces();
+        delete linep;
+      }
+      met_with_kword_space = 0;
+    }
+#endif
     hyphenate_line(start_here);
     breakpoint *bp = choose_breakpoint();
     if (bp == 0)
@@ -2024,6 +2186,15 @@
     bp->nd->split(bp->index, &pre, &post);
     *ndp = post;
     hunits extra_space_width = H0;
+#ifdef NIPPON
+    int sv_adjust_mode = adjust_mode;
+    if (stretch_threshold) {
+	int ratio = bp->width * 100 / target_text_length;
+	if ( ratio < stretch_threshold) {
+	    adjust_mode = ADJUST_LEFT;
+	}
+    }
+#endif
     switch(adjust_mode) {
     case ADJUST_BOTH:
       if (bp->nspaces != 0)
@@ -2039,6 +2210,9 @@
       saved_indent += target_text_length - bp->width;
       break;
     }
+#ifdef NIPPON
+    adjust_mode = sv_adjust_mode;
+#endif
     distribute_space(pre, bp->nspaces, extra_space_width);
     hunits output_width = bp->width + extra_space_width;
     input_line_start -= output_width;
@@ -3230,6 +3404,9 @@
   init_request("hys", hyphenation_space_request);
   init_request("hym", hyphenation_margin_request);
   init_request("pvs", post_vertical_spacing);
+#ifdef NIPPON
+  init_request("stt", stretch_threshold_request);
+#endif
   init_int_env_reg(".f", get_font);
   init_int_env_reg(".b", get_bold);
   init_hunits_env_reg(".i", get_indent);
--- groff-1.18.orig/src/roff/troff/env.h
+++ groff-1.18/src/roff/troff/env.h
@@ -183,6 +183,15 @@
 #ifdef WIDOW_CONTROL
   int widow_control;
 #endif /* WIDOW_CONTROL */
+#ifdef	NIPPON
+  int stretch_threshold;
+  int pre_wchar_cannot_break_after;
+  int pre_char_is_ascii;
+  int enable_wcharkern;
+  int met_with_kword_space;
+  hunits hwkern;
+  vunits vlower;
+#endif
   int ignore_next_eol;
   int emitted_node;    // have we emitted a node since the last html eol tag?
   color *cur_glyph_color;
@@ -279,6 +288,10 @@
   void wrap_up_tab();
   void set_font(int);
   void set_font(symbol);
+#ifdef	NIPPON
+  void change_curfont(int);
+  void change_curfont(symbol);
+#endif
   void set_family(symbol);
   void set_size(int);
   void set_char_height(int);
@@ -347,6 +360,9 @@
 #ifdef WIDOW_CONTROL
   friend void widow_control_request();
 #endif /* WIDOW_CONTROL */
+#ifdef	NIPPON
+  friend void stretch_threshold_request();
+#endif
 
   friend void do_divert(int append, int boxing);
 };
--- groff-1.18.orig/src/roff/troff/input.cc
+++ groff-1.18/src/roff/troff/input.cc
@@ -35,6 +35,7 @@
 #include "macropath.h"
 #include "defs.h"
 #include "input.h"
+#include "encoding.h" // XXX: ukai
 
 // Needed for getpid().
 #include "posix.h"
@@ -100,6 +101,27 @@
 charinfo *charset_table[256];
 unsigned char hpf_code_table[256];
 
+#ifdef	NIPPON
+charinfo **wcharset_table = NULL;
+
+charinfo *wcharset_table_entry(wchar wc)
+{
+  return wcharset_table[encoding->wchar_table_index(wc)];
+}
+
+static int mount_on_demand(const char *font_name)
+{
+  const char **p = font::on_demand_fonts;
+
+  while (p && *p) {
+    if (strcmp(*p, font_name) == 0)
+      return(1);
+    p++;
+  }
+  return(0);
+}    
+#endif /* NIPPON */
+
 static int warning_mask = DEFAULT_WARNING_MASK;
 static int inhibit_errors = 0;
 static int ignoring = 0;
@@ -1533,6 +1555,19 @@
   type = TOKEN_NEWLINE;
 }
 
+#ifdef NIPPON
+class encoding_istream_input : public encoding_istream {
+private:
+  node **np;
+public:
+  encoding_istream_input(node **n) : np(n) {};
+  ~encoding_istream_input() {};
+  int getbyte() { return input_stack::get(np); };
+  int peekbyte() { return input_stack::peek(); };
+  void ungetbyte(int ch) { return; };
+};
+#endif
+
 void token::next()
 {
   if (nd) {
@@ -1542,6 +1577,10 @@
   units x;
   for (;;) {
     node *n;
+#ifdef NIPPON
+    encoding_istream_input einput(&n);
+#endif
+
     int cc = input_stack::get(&n);
     if (cc != escape_char || escape_char == 0) {
     handle_normal_char:
@@ -1693,8 +1732,22 @@
 	}
 	return;
       default:
+#ifdef	NIPPON
+	wc = encoding->make_wchar(cc, einput);
+	if (encoding->is_wchar_code(wc)) {
+	  type = TOKEN_WCHAR;
+	  c = 0;
+	} else if (wc == ' ') {
+	  type = TOKEN_SPACE;
+	  c = cc;
+	} else {
+	  type = TOKEN_CHAR;
+	  c = cc;
+	}
+#else
 	type = TOKEN_CHAR;
 	c = cc;
+#endif
 	return;
       }
     }
@@ -2063,6 +2116,10 @@
   switch(type) {
   case TOKEN_CHAR:
     return c == t.c;
+#ifdef	NIPPON
+  case TOKEN_WCHAR:
+    return wc == t.wc;
+#endif
   case TOKEN_SPECIAL:
     return nm == t.nm;
   case TOKEN_NUMBERED_CHAR:
@@ -2530,6 +2587,9 @@
 {
   int_stack trap_bol_stack;
   int bol = 1;
+#ifdef NIPPON
+  int fontno;
+#endif
   for (;;) {
     int suppress_next = 0;
     switch (tok.type) {
@@ -2569,6 +2629,33 @@
 	}
 	break;
       }
+#ifdef	NIPPON
+    case token::TOKEN_WCHAR:
+      {
+	wchar wch = tok.wc;
+
+	if (possibly_handle_first_page_transition())
+	  ;
+	else {
+	  for (;;) {
+	    fontno = curenv->get_font(); // save a current font #
+	    if (is_boldfont(fontno))
+	      curenv->change_curfont(symbol("G")); // set Gothic font
+	    else
+	      curenv->change_curfont(symbol("M")); // set Mintyo font
+	    curenv->add_char(wcharset_table_entry(wch));
+	    curenv->change_curfont(fontno); // restore a saved font #
+	    tok.next();
+	    if (tok.type != token::TOKEN_WCHAR)
+	      break;
+	    wch = tok.wc;
+	  }
+	  suppress_next = 1;
+	  bol = 0;
+	}
+	break;
+      }
+#endif	/* NIPPON */
     case token::TOKEN_TRANSPARENT:
       {
 	if (bol) {
@@ -5520,6 +5607,37 @@
   }
 }
 
+#ifdef NIPPON
+static void init_wchar_charinfo(wchar wc, void *arg)
+{
+  char buf[16];
+  charinfo *ci;
+  sprintf(buf, "wchar%x", wc);
+  wcharset_table[encoding->wchar_table_index(wc)] = get_charinfo(symbol(buf));
+  ci = wcharset_table[encoding->wchar_table_index(wc)];
+  ci->set_wchar_code(wc);
+}
+
+#if 0
+void encoding_request()
+{
+  symbol nm = get_long_name(1);
+  if (nm.is_null())
+    skip_line();
+  else {
+    while (!tok.newline() && !tok.eof())
+      tok.next();
+    if (wcharset_table)
+      delete [] wcharset_table;
+    new_encoding_handler(nm.contents());
+    wcharset_table = (charinfo**)encoding->init_table();
+    encoding->foreach_wchar(init_wchar_charinfo, wcharset_table);
+    tok.next();
+  }
+}
+#endif
+#endif
+
 const char *asciify(int c)
 {
   static char buf[3];
@@ -6023,6 +6141,10 @@
 {
   if (type == TOKEN_CHAR)
     return charset_table[c];
+#ifdef	NIPPON
+  if (type == TOKEN_WCHAR)
+    return wcharset_table_entry(wc);
+#endif
   if (type == TOKEN_SPECIAL)
     return get_charinfo(nm);
   if (type == TOKEN_NUMBERED_CHAR)
@@ -6071,10 +6193,24 @@
   hunits w;
   int s;
   node *n = 0;
+#ifdef NIPPON
+  int fontno;
+#endif
   switch (type) {
   case TOKEN_CHAR:
     *pp = (*pp)->add_char(charset_table[c], curenv, &w, &s);
     break;
+#ifdef	NIPPON
+  case TOKEN_WCHAR:
+    fontno = curenv->get_font(); // save a current font #
+    if (is_boldfont(fontno))
+      curenv->change_curfont(symbol("G")); // set Gothic font
+    else
+      curenv->change_curfont(symbol("M")); // set Mintyo font
+    *pp = (*pp)->add_char(wcharset_table_entry(wc), curenv, &w, &s);
+    curenv->change_curfont(fontno); // restore a saved font #
+    break;
+#endif
   case TOKEN_DUMMY:
     n = new dummy_node;
     break;
@@ -6134,6 +6270,9 @@
 
 void token::process()
 {
+#ifdef NIPPON
+  int fontno;
+#endif
   if (possibly_handle_first_page_transition())
     return;
   switch (type) {
@@ -6143,6 +6282,17 @@
   case TOKEN_CHAR:
     curenv->add_char(charset_table[c]);
     break;
+#ifdef	NIPPON
+  case TOKEN_WCHAR:
+    fontno = curenv->get_font(); // save a current font #
+    if (is_boldfont(fontno))
+      curenv->change_curfont(symbol("G")); // set Gothic font
+    else
+      curenv->change_curfont(symbol("M")); // set Mintyo font
+    curenv->add_char(wcharset_table_entry(wc));
+    curenv->change_curfont(fontno); // restore a saved font #
+    break;
+#endif
   case TOKEN_DUMMY:
     curenv->add_node(new dummy_node);
     break;
@@ -6768,6 +6918,7 @@
   program_name = argv[0];
   static char stderr_buf[BUFSIZ];
   setbuf(stderr, stderr_buf);
+  init_encoding_handler();
   int c;
   string_list *macros = 0;
   string_list *register_assignments = 0;
@@ -6901,6 +7052,10 @@
   set_string(".T", device);
   init_charset_table();
   init_hpf_code_table();
+#ifdef NIPPON
+  wcharset_table = (charinfo**)encoding->init_table();
+  encoding->foreach_wchar(init_wchar_charinfo, wcharset_table);
+#endif
   if (!font::load_desc())
     fatal("sorry, I can't continue");
   units_per_inch = font::res;
@@ -6923,6 +7078,9 @@
     // In the DESC file a font name of 0 (zero) means leave this
     // position empty.
     if (strcmp(font::font_name_table[i], "0") != 0)
+#ifdef NIPPON
+      if (!mount_on_demand(font::font_name_table[i]))
+#endif
       mount_font(j, symbol(font::font_name_table[i]));
   curdiv = topdiv = new top_level_diversion;
   if (nflag)
@@ -7103,6 +7261,9 @@
   init_request("pi", pipe_output);
   init_request("pm", print_macros);
   init_request("psbb", ps_bbox_request);
+#if 0 /* def NIPPON */
+  init_request("encoding", encoding_request);
+#endif
 #ifndef POPEN_MISSING
   init_request("pso", pipe_source);
 #endif /* not POPEN_MISSING */
@@ -7545,6 +7706,9 @@
 charinfo::charinfo(symbol s)
 : translation(0), mac(0), special_translation(TRANSLATE_NONE),
   hyphenation_code(0), flags(0), ascii_code(0), asciify_code(0),
+#ifdef NIPPON
+  wchar_code(0),
+#endif
   not_found(0), transparent_translate(1), translate_input(0),
   fallback(0), nm(s)
 {
@@ -7589,6 +7753,13 @@
   asciify_code = c;
 }
 
+#ifdef NIPPON
+void charinfo::set_wchar_code(wchar wc)
+{
+  wchar_code = wc;
+}
+#endif
+
 macro *charinfo::set_macro(macro *m, int f)
 {
   macro *tem = mac;
@@ -7644,6 +7815,13 @@
 int font::name_to_index(const char *nm)
 {
   charinfo *ci;
+#ifdef	NIPPON
+  int i = 1;
+  wchar wc = encoding->make_wchar(nm[0], (const unsigned char *)nm, &i);
+  if (encoding->is_wchar_code(wc)) {
+    ci = wcharset_table_entry(wc);
+  } else
+#endif
   if (nm[1] == 0)
     ci = charset_table[nm[0] & 0xff];
   else if (nm[0] == '\\' && nm[2] == 0)
@@ -7660,3 +7838,10 @@
 {
   return get_charinfo_by_number(n)->get_index();
 }
+
+#ifdef	NIPPON
+int font::wchar_index(wchar wc)
+{
+  return(wcharset_table_entry(wc)->get_index());
+}
+#endif
--- groff-1.18.orig/src/roff/troff/node.cc
+++ groff-1.18/src/roff/troff/node.cc
@@ -38,6 +38,7 @@
 #include "input.h"
 #include "div.h"
 #include "geometry.h"
+#include "encoding.h"
 
 #include "nonposix.h"
 
@@ -151,6 +152,9 @@
   int is_special();
   int is_style();
   friend symbol get_font_name(int, environment *);
+#ifdef NIPPON
+  friend int is_boldfont(int);
+#endif
 };
 
 class tfont_spec {
@@ -399,6 +403,15 @@
   return f;
 }
 
+#ifdef	NIPPON
+int is_boldfont(int fontno)
+{
+  hunits h;
+  return font_table[fontno]->get_bold(&h);
+}
+#endif
+
+
 hunits font_info::get_space_width(font_size fs, int space_size)
 {
   if (is_constant_spaced == CONSTANT_SPACE_NONE)
@@ -746,7 +759,11 @@
   symbol *font_position;
   int nfont_positions;
   enum { TBUF_SIZE = 256 };
+#ifdef	NIPPON
+  wchar tbuf[TBUF_SIZE];
+#else
   char tbuf[TBUF_SIZE];
+#endif
   int tbuf_len;
   int tbuf_kern;
   int begun_page;
@@ -756,6 +773,9 @@
   void put(int i);
   void put(unsigned int i);
   void put(const char *s);
+#ifdef	NIPPON
+  void putw(const wchar wc);
+#endif
   void set_font(tfont *tf);
   void flush_tbuf();
 public:
@@ -799,6 +819,13 @@
   putc(c, fp);
 }
 
+#ifdef	NIPPON
+inline void troff_output_file::putw(const wchar wc)
+{
+  encoding->put_wchar(wc, fp);
+}
+#endif
+
 inline void troff_output_file::put(unsigned char c)
 {
   putc(c, fp);
@@ -961,7 +988,11 @@
   check_output_limits(hpos, vpos - current_size);
 
   for (int i = 0; i < tbuf_len; i++)
+#ifdef NIPPON
+    putw(tbuf[i]);
+#else
     put(tbuf[i]);
+#endif
   put('\n');
   tbuf_len = 0;
 }
@@ -992,7 +1023,13 @@
     flush_tbuf();
     set_font(tf);
   }
+#ifdef NIPPON
+  wchar c = ci->get_wchar_code();
+  if (c == '\0')
+    c = ci->get_ascii_code();
+#else
   char c = ci->get_ascii_code();
+#endif
   if (c == '\0') {
     flush_tbuf();
     do_motion();
@@ -1040,13 +1077,21 @@
     if (vpos == output_vpos && n > 0 && n < 100 && !force_motion) {
       put(char(n/10 + '0'));
       put(char(n%10 + '0'));
+#ifdef NIPPON
+      putw(c);
+#else
       put(c);
+#endif
       output_hpos = hpos;
     }
     else {
       do_motion();
       put('c');
+#ifdef NIPPON
+      putw(c);
+#else
       put(c);
+#endif
     }
     hpos += w.to_units() + kk;
   }
@@ -1060,7 +1105,13 @@
 
   if (tf != current_tfont)
     set_font(tf);
+#ifdef	NIPPON
+  wchar c = ci->get_wchar_code();
+  if (c == '\0')
+    c = ci->get_ascii_code();
+#else
   char c = ci->get_ascii_code();
+#endif
   if (c == '\0') {
     do_motion();
     if (ci->numbered()) {
@@ -1084,13 +1135,21 @@
     if (vpos == output_vpos && n > 0 && n < 100) {
       put(char(n/10 + '0'));
       put(char(n%10 + '0'));
+#ifdef NIPPON
+      putw(c);
+#else
       put(c);
+#endif
       output_hpos = hpos;
     }
     else {
       do_motion();
       put('c');
+#ifdef NIPPON
+      putw(c);
+#else
       put(c);
+#endif
     }
   }
 }
@@ -1764,6 +1823,9 @@
   int same(node *);
   const char *type();
   int force_tprint();
+#ifdef	NIPPON
+  node_type get_node_type();
+#endif
 };
 
 glyph_node *glyph_node::free_list = 0;
@@ -2818,6 +2880,7 @@
   bracket_node *on = new bracket_node;
   node *last = 0;
   node *tem;
+  list->last = 0;
   for (tem = list; tem; tem = tem->next) {
     if (tem->next)
       tem->next->last = tem;
@@ -5228,6 +5291,49 @@
 {
   return 0;
 }
+
+#ifdef	NIPPON
+kword_space_node::kword_space_node(node *x) : word_space_node(0, new width_list(0, 0), x)
+{}
+
+node *kword_space_node::copy()
+{
+    return new kword_space_node(0);
+}
+newline_space_node::newline_space_node(hunits d, node *x) : word_space_node(d, new width_list(0, 0), x)
+{}
+
+node *newline_space_node::copy()
+{
+    return new newline_space_node(n);
+}
+
+const char *kword_space_node::type()
+{
+  return "kword_space_node";
+}
+const char *newline_space_node::type()
+{
+  return "newline_space_node";
+}
+
+node_type node::get_node_type()
+{
+    return NODE_ANOTHER;
+}
+node_type glyph_node::get_node_type()
+{
+    return NODE_GLYPH;
+}
+node_type kword_space_node::get_node_type()
+{
+    return NODE_KWORD_SPACE;
+}
+node_type newline_space_node::get_node_type()
+{
+    return NODE_NEWLINE_SPACE;
+}
+#endif
 
 int unbreakable_space_node::same(node *nd)
 {
--- groff-1.18.orig/src/roff/troff/node.h
+++ groff-1.18/src/roff/troff/node.h
@@ -31,6 +31,9 @@
 void hyphenate(hyphen_list *, unsigned);
 
 enum hyphenation_type { HYPHEN_MIDDLE, HYPHEN_BOUNDARY, HYPHEN_INHIBIT };
+#ifdef	NIPPON
+enum node_type {NODE_GLYPH, NODE_KWORD_SPACE, NODE_NEWLINE_SPACE, NODE_ANOTHER};
+#endif
 
 class ascii_output_file;
 
@@ -104,6 +107,9 @@
 
   virtual int same(node *) = 0;
   virtual const char *type() = 0;
+#ifdef	NIPPON
+  virtual node_type get_node_type();
+#endif
 };
 
 inline node::node() : next(0), last(0)
@@ -207,6 +213,24 @@
   int force_tprint();
 };
 
+#ifdef	NIPPON
+class kword_space_node : public word_space_node {
+public:
+  kword_space_node(node * = 0);
+  node *copy();
+  const char *type();
+  node_type get_node_type();
+};
+
+class newline_space_node : public word_space_node {
+public:
+  newline_space_node(hunits, node * = 0);
+  node *copy();
+  const char *type();
+  node_type get_node_type();
+};
+#endif
+
 class unbreakable_space_node : public word_space_node {
   unbreakable_space_node(hunits, int, node * = 0);
 public:
@@ -608,3 +632,7 @@
 
 font_family *lookup_family(symbol);
 symbol get_font_name(int, environment *);
+#ifdef NIPPON
+int is_boldfont(int);
+#endif
+
--- groff-1.18.orig/src/roff/troff/token.h
+++ groff-1.18/src/roff/troff/token.h
@@ -28,12 +28,18 @@
   symbol nm;
   node *nd;
   unsigned char c;
+#ifdef	NIPPON
+  wchar wc;
+#endif
   int val;
   units dim;
   enum token_type {
     TOKEN_BACKSPACE,
     TOKEN_BEGIN_TRAP,
     TOKEN_CHAR,			// a normal printing character
+#ifdef	NIPPON
+    TOKEN_WCHAR,		// a japanese EUC character
+#endif
     TOKEN_DUMMY,		// \&
     TOKEN_EMPTY,		// this is the initial value
     TOKEN_END_TRAP,
--- groff-1.18.orig/src/roff/troff/troff.h
+++ groff-1.18/src/roff/troff/troff.h
@@ -20,6 +20,9 @@
 Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
 
 
+#ifdef	NIPPON
+# include "eucmac.h"
+#endif
 #include "lib.h"
 
 #include <ctype.h>
--- groff-1.18.orig/src/roff/nroff/nroff.man
+++ groff-1.18/src/roff/nroff/nroff.man
@@ -53,8 +53,10 @@
 command using groff.
 Only 
 .BR ascii ,
+.BR ascii8 ,
 .BR latin1 ,
 .BR utf8 ,
+.BR nippon ,
 and
 .B cp1047
 are valid arguments for the
--- groff-1.18.orig/src/roff/nroff/nroff.sh
+++ groff-1.18/src/roff/nroff/nroff.sh
@@ -12,6 +12,8 @@
     T=-Tlatin1 ;;
   IBM-1047)
     T=-Tcp1047 ;;
+  EUC-JP)
+    T=-Tnippon ;;
   *)
     case "${LC_ALL-${LC_CTYPE-${LANG}}}" in
       *.UTF-8)
@@ -20,6 +22,8 @@
         T=-Tlatin1 ;;
       *.IBM-1047)
         T=-Tcp1047 ;;
+      ja_JP.ujis | ja_JP.eucJP)
+	T=-Tnippon ;;
       *)
         case "$LESSCHARSET" in
           utf-8)
@@ -28,8 +32,10 @@
             T=-Tlatin1 ;;
           cp1047)
             T=-Tcp1047 ;;
+          japanese)
+	    T=-Tnippon ;;
           *)
-            T=-Tascii ;;
+            T=-Tascii8 ;;
           esac ;;
      esac ;;
 esac
@@ -52,7 +58,7 @@
       exit 1 ;;
     -[iptSUC] | -[mrno]*)
       opts="$opts $1" ;;
-    -Tascii | -Tlatin1 | -Tutf8 | -Tcp1047)
+    -Tascii | -Tlatin1 | -Tutf8 | -Tcp1047 | -Tascii8 | -Tnippon)
       T=$1 ;;
     -T*)
       # ignore other devices
--- groff-1.18.orig/src/preproc/eqn/eqn.h
+++ groff-1.18/src/preproc/eqn/eqn.h
@@ -23,6 +23,9 @@
 #include <assert.h>
 #include <stdlib.h>
 #include <errno.h>
+#ifdef	NIPPON
+# include "eucmac.h"
+#endif
 #include "cset.h"
 #include "errarg.h"
 #include "error.h"
--- groff-1.18.orig/src/preproc/eqn/eqn.y
+++ groff-1.18/src/preproc/eqn/eqn.y
@@ -21,6 +21,7 @@
 #include <string.h>
 #include <stdlib.h>
 
+#include "encoding.h" /* XXX */
 #include "lib.h"
 #include "box.h"
 extern int non_empty_flag;
--- groff-1.18.orig/src/preproc/eqn/lex.cc
+++ groff-1.18/src/preproc/eqn/lex.cc
@@ -23,6 +23,7 @@
 #include "eqn_tab.h"
 #include "stringclass.h"
 #include "ptable.h"
+#include "encoding.h"
 
 struct definition {
   char is_macro;
@@ -375,6 +376,11 @@
 	lex_error("invalid input character code %1", c);
       else {
 	line += char(c);
+#ifdef	NIPPON
+	if (encoding->is_wchar_byte(c)) {
+	  line += char(getc(fp));
+	}
+#endif
 	if (c == '\n') 
 	  break;
       }
--- groff-1.18.orig/src/preproc/eqn/main.cc
+++ groff-1.18/src/preproc/eqn/main.cc
@@ -258,6 +258,7 @@
   program_name = argv[0];
   static char stderr_buf[BUFSIZ];
   setbuf(stderr, stderr_buf);
+  init_encoding_handler();
   int opt;
   int load_startup_file = 1;
   static const struct option long_options[] = {
--- groff-1.18.orig/src/preproc/eqn/text.cc
+++ groff-1.18/src/preproc/eqn/text.cc
@@ -21,13 +21,20 @@
 #include "eqn.h"
 #include "pbox.h"
 #include "ptable.h"
+#include "encoding.h"
 
 class char_box : public simple_box {
   unsigned char c;
+#ifdef	NIPPON
+  wchar wc;
+#endif
   char next_is_italic;
   char prev_is_italic;
 public:
   char_box(unsigned char);
+#ifdef	NIPPON
+  char_box(unsigned char, wchar);
+#endif
   void debug_print();
   void output();
   int is_char();
@@ -166,10 +173,20 @@
 
 char_box::char_box(unsigned char cc)
 : c(cc), next_is_italic(0), prev_is_italic(0)
+#ifdef	NIPPON
+, wc(cc)
+#endif
 {
   spacing_type = char_table[c].spacing_type;
 }
 
+#ifdef	NIPPON
+char_box::char_box(unsigned char cc, wchar wc)
+: c(cc), wc(wc), prev_is_italic(0), next_is_italic(0)
+{
+}
+#endif
+
 void char_box::hint(unsigned flags)
 {
   if (flags & HINT_PREV_IS_ITALIC)
@@ -188,7 +205,11 @@
   if (c == '\\')
     fputs("\\e", stdout);
   else
+#ifdef	NIPPON
+    encoding->put_wchar(wc, stdout);
+#else
     putchar(c);
+#endif
   if (!next_is_italic)
     fputs("\\/", stdout);
   else
@@ -497,6 +518,14 @@
       break;
     default:
     normal_char:
+#ifdef	NIPPON
+      if (encoding->is_wchar_byte(c)) {
+        int i = 1;
+	wchar wc = encoding->make_wchar(c, (unsigned char *)s, &i);
+	b = new char_box('A', wc); // char_info of wc is same the 'A'.
+	s += i;
+      } else
+#endif
       b = new char_box(c);
       break;
     }
--- groff-1.18.orig/src/preproc/html/pre-html.cc
+++ groff-1.18/src/preproc/html/pre-html.cc
@@ -238,12 +238,13 @@
       char *p = linebuf + 9;
       while (*p == ' ' || *p == '\t')
 	p++;
-      if (font::scan_papersize(p, 0, &length, 0)) {
-	fclose(f);
-	return int(length * postscriptRes + 0.5);
+      for (p = strtok(p, " \t"); p; p = strtok(0, " \t")) {
+	if (font::scan_papersize(p, 0, &length, 0)) {
+	  fclose(f);
+	  return int(length * postscriptRes + 0.5);
+	}
       }
-      else
-	fatal("bad argument to `papersize' keyword in devps/DESC");
+      fatal("bad argument to `papersize' keyword in devps/DESC");
     }
   }
   fatal("can't find `papersize' or `paperlength' keyword in devps/DESC");
--- groff-1.18.orig/src/devices/grops/ps.cc
+++ groff-1.18/src/devices/grops/ps.cc
@@ -24,6 +24,7 @@
 #include "cset.h"
 #include "nonposix.h"
 #include "paper.h"
+#include "encoding.h"
 
 #include "ps.h"
 #include <time.h>
@@ -193,12 +194,20 @@
   return *this;
 }
 
+#ifdef NIPPON
+ps_output &ps_output::put_string(const wchar *s, int n)
+#else
 ps_output &ps_output::put_string(const char *s, int n)
+#endif
 {
   int len = 0;
   int i;
   for (i = 0; i < n; i++) {
+#ifdef NIPPON
+    wchar c = s[i];
+#else
     char c = s[i];
+#endif
     if (is_ascii(c) && csprint(c)) {
       if (c == '(' || c == ')' || c == '\\')
 	len += 2;
@@ -224,8 +233,13 @@
 	putc('\n', fp);
 	col = 0;
       }
+#ifdef	NIPPON
+      int nb = encoding->put_wchar(s[i], fp, "%02x");
+      col += nb * 2;
+#else
       fprintf(fp, "%02x", s[i] & 0377);
       col += 2;
+#endif
     }
     putc('>', fp);
     col++;
@@ -487,7 +501,11 @@
   int paper_length;
   int equalise_spaces;
   enum { SBUF_SIZE = 256 };
+#ifdef	NIPPON
+  wchar sbuf[SBUF_SIZE];
+#else
   char sbuf[SBUF_SIZE];
+#endif
   int sbuf_len;
   int sbuf_start_hpos;
   int sbuf_vpos;
@@ -606,7 +624,11 @@
 {
   if (i == space_char_index || invis_count > 0)
     return;
+#ifdef	NIPPON
+  wchar code = f->get_code(i);
+#else
   unsigned char code = f->get_code(i);
+#endif
   style sty(f, env->size, env->height, env->slant);
   if (sty.slant != 0) {
     if (sty.slant > 80 || sty.slant < -80) {
@@ -1555,6 +1577,7 @@
   string env;
   static char stderr_buf[BUFSIZ];
   setbuf(stderr, stderr_buf);
+  init_encoding_handler();
   int c;
   static const struct option long_options[] = {
     { "help", no_argument, 0, CHAR_MAX + 1 },
--- groff-1.18.orig/src/devices/grops/ps.h
+++ groff-1.18/src/devices/grops/ps.h
@@ -18,10 +18,16 @@
 with groff; see the file COPYING.  If not, write to the Free Software
 Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
 
+#include "encoding.h" // XXX
+
 class ps_output {
 public:
   ps_output(FILE *, int max_line_length);
+#ifdef	NIPPON
+  ps_output &put_string(const wchar *, int);
+#else
   ps_output &put_string(const char *, int);
+#endif
   ps_output &put_number(int);
   ps_output &put_fix_number(int);
   ps_output &put_float(double);
--- groff-1.18.orig/src/devices/grotty/grotty.man
+++ groff-1.18/src/devices/grotty/grotty.man
@@ -50,7 +50,9 @@
 command
 with a
 .BR \-Tascii ,
-.B \-Tlatin1
+.BR \-Tascii8 ,
+.BR \-Tlatin1 ,
+.B \-Tnippon
 or
 .B \-Tutf8
 option on ASCII based systems, and with
@@ -235,8 +237,10 @@
 .I name
 is the name of the device, usually
 .BR ascii ,
+.BR ascii8 ,
 .BR latin1 ,
 .BR utf8 ,
+.B  nippon
 or
 .BR cp1047 .
 .TP
@@ -315,9 +319,19 @@
 device.
 .
 .TP
+.B @FONTDIR@/devascii8/DESC
+Device description file for
+.B ascii8
+device.
+.TP
 .B @FONTDIR@/devlatin1/DESC
 Device description file for
 .B latin1
+device.
+.TP
+.B @FONTDIR@/devnippon/DESC
+Device description file for
+.B nippon
 device.
 .
 .TP
